package api

import play.api.libs.json._
import model.JsObject
import model.Ok
import model.UserExtended

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait AccountApi {
  /**
    * Get my preferences
    * Read the preferences of the logged in user.  - &lt;https://lichess.org/account/preferences/game-display&gt; - &lt;https://github.com/ornicar/lila/blob/master/modules/pref/src/main/Pref.scala&gt; 
    */
  def account(): JsObject

  /**
    * Get my email address
    * Read the email address of the logged in user. 
    */
  def accountEmail(): JsObject

  /**
    * Get my kid mode status
    * Read the kid mode status of the logged in user.  - &lt;https://lichess.org/account/kid&gt; 
    */
  def accountKid(): JsObject

  /**
    * Set my kid mode status
    * Set the kid mode status of the logged in user.  - &lt;https://lichess.org/account/kid&gt; 
    * @param v Kid mode status
    */
  def accountKidPost(v: Boolean): Ok

  /**
    * Get my profile
    * Public informations about the logged in user. 
    */
  def accountMe(): UserExtended
}
