package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.JsObject
import model.Ok
import model.UserExtended

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class AccountApiController @Inject()(cc: ControllerComponents, api: AccountApi) extends AbstractController(cc) {
  /**
    * GET /api/account/preferences
    */
  def account(): Action[AnyContent] = Action { request =>
    def executeApi(): JsObject = {
      api.account()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/account/email
    */
  def accountEmail(): Action[AnyContent] = Action { request =>
    def executeApi(): JsObject = {
      api.accountEmail()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/account/kid
    */
  def accountKid(): Action[AnyContent] = Action { request =>
    def executeApi(): JsObject = {
      api.accountKid()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/account/kid?v=[value]
    */
  def accountKidPost(): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val v = request.getQueryString("v")
        .map(value => value.toBoolean)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("v", "query string")
        }
      api.accountKidPost(v)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/account
    */
  def accountMe(): Action[AnyContent] = Action { request =>
    def executeApi(): UserExtended = {
      api.accountMe()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
