package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.BigDecimal
import model.VariantKey

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class AnalysisApiController @Inject()(cc: ControllerComponents, api: AnalysisApi) extends AbstractController(cc) {
  /**
    * GET /api/cloud-eval?fen=[value]&multiPv=[value]&variant=[value]
    */
  def apiCloudEval(): Action[AnyContent] = Action { request =>
    def executeApi(): Unit = {
      val fen = request.getQueryString("fen")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("fen", "query string")
        }
      val multiPv = request.getQueryString("multiPv")
        .map(value => BigDecimal(value))
      val variant = request.getQueryString("variant")
        .map(value => )
      api.apiCloudEval(fen, multiPv, variant)
    }

    executeApi()
    Ok
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
