package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.ArenaTournaments
import model.BigDecimal
import model.Error
import model.OasAnyTypeNotMapped
import model.Ok
import model.VariantKey

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class ArenaTournamentsApiController @Inject()(cc: ControllerComponents, api: ArenaTournamentsApi) extends AbstractController(cc) {
  /**
    * GET /api/team/:teamId/arena?max=[value]
    * @param teamId ID of the team
    */
  def apiTeamArena(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): List[OasAnyTypeNotMapped] = {
      val max = request.getQueryString("max")
        .map(value => value.toInt)
      api.apiTeamArena(teamId, max)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tournament
    */
  def apiTournament(): Action[AnyContent] = Action { request =>
    def executeApi(): ArenaTournaments = {
      api.apiTournament()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/tournament/:id/join
    * @param id The tournament ID.
    */
  def apiTournamentJoin(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val password = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("password"))
        .flatMap(_.headOption)
        
      val team = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("team"))
        .flatMap(_.headOption)
        
      api.apiTournamentJoin(id, password, team)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/tournament
    */
  def apiTournamentPost(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val name = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("name"))
        .flatMap(_.headOption)
        
      val clockTime = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clockTime"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("clockTime", "form")
        }
      val clockIncrement = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clockIncrement"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("clockIncrement", "form")
        }
      val minutes = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("minutes"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("minutes", "form")
        }
      val waitMinutes = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("waitMinutes"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val startDate = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("startDate"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val variant = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("variant"))
        .flatMap(_.headOption)
        .map(value => )
      val rated = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("rated"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val position = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("position"))
        .flatMap(_.headOption)
        
      val berserkable = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("berserkable"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val streakable = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("streakable"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val hasChat = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("hasChat"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val description = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("description"))
        .flatMap(_.headOption)
        
      val password = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("password"))
        .flatMap(_.headOption)
        
      val teambBattleByTeam = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("teambBattleByTeam"))
        .flatMap(_.headOption)
        
      val conditionsPeriodteamMemberPeriodteamId = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.teamMember.teamId"))
        .flatMap(_.headOption)
        
      val conditionsPeriodminRatingPeriodrating = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.minRating.rating"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val conditionsPeriodmaxRatingPeriodrating = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.maxRating.rating"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val conditionsPeriodnbRatedGamePeriodnb = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.nbRatedGame.nb"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      api.apiTournamentPost(clockTime, clockIncrement, minutes, name, waitMinutes, startDate, variant, rated, position, berserkable, streakable, hasChat, description, password, teambBattleByTeam, conditionsPeriodteamMemberPeriodteamId, conditionsPeriodminRatingPeriodrating, conditionsPeriodmaxRatingPeriodrating, conditionsPeriodnbRatedGamePeriodnb)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/tournament/team-battle/:id
    * @param id The tournament ID (8 characters)..
    */
  def apiTournamentTeamBattlePost(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val teams = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("teams"))
        .flatMap(_.headOption)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("teams", "form")
        }
      val nbLeaders = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("nbLeaders"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("nbLeaders", "form")
        }
      api.apiTournamentTeamBattlePost(id, teams, nbLeaders)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/tournament/:id/terminate
    * @param id The tournament ID.
    */
  def apiTournamentTerminate(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.apiTournamentTerminate(id)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/tournament/:id
    * @param id The tournament ID.
    */
  def apiTournamentUpdate(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val name = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("name"))
        .flatMap(_.headOption)
        
      val clockTime = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clockTime"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("clockTime", "form")
        }
      val clockIncrement = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clockIncrement"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("clockIncrement", "form")
        }
      val minutes = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("minutes"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("minutes", "form")
        }
      val waitMinutes = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("waitMinutes"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val startDate = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("startDate"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val variant = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("variant"))
        .flatMap(_.headOption)
        .map(value => )
      val rated = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("rated"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val position = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("position"))
        .flatMap(_.headOption)
        
      val berserkable = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("berserkable"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val streakable = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("streakable"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val hasChat = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("hasChat"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val description = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("description"))
        .flatMap(_.headOption)
        
      val password = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("password"))
        .flatMap(_.headOption)
        
      val conditionsPeriodminRatingPeriodrating = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.minRating.rating"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val conditionsPeriodmaxRatingPeriodrating = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.maxRating.rating"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val conditionsPeriodnbRatedGamePeriodnb = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("conditions.nbRatedGame.nb"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      api.apiTournamentUpdate(id, clockTime, clockIncrement, minutes, name, waitMinutes, startDate, variant, rated, position, berserkable, streakable, hasChat, description, password, conditionsPeriodminRatingPeriodrating, conditionsPeriodmaxRatingPeriodrating, conditionsPeriodnbRatedGamePeriodnb)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/tournament/:id/withdraw
    * @param id The tournament ID.
    */
  def apiTournamentWithdraw(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.apiTournamentWithdraw(id)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/user/:username/tournament/created?status=[value]
    * @param username The user whose created tournaments to fetch
    */
  def apiUserNameTournamentCreated(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val status = request.getQueryString("status")
        .map(value => value.toInt)
      api.apiUserNameTournamentCreated(username, status)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tournament/:id/games?player=[value]&moves=[value]&pgnInJson=[value]&tags=[value]&clocks=[value]&evals=[value]&opening=[value]
    * @param id The tournament ID.
    */
  def gamesByTournament(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val player = request.getQueryString("player")
        
      val moves = request.getQueryString("moves")
        .map(value => value.toBoolean)
      val pgnInJson = request.getQueryString("pgnInJson")
        .map(value => value.toBoolean)
      val tags = request.getQueryString("tags")
        .map(value => value.toBoolean)
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val evals = request.getQueryString("evals")
        .map(value => value.toBoolean)
      val opening = request.getQueryString("opening")
        .map(value => value.toBoolean)
      api.gamesByTournament(id, player, moves, pgnInJson, tags, clocks, evals, opening)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tournament/:id/results?nb=[value]
    * @param id The tournament ID.
    */
  def resultsByTournament(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val nb = request.getQueryString("nb")
        .map(value => value.toInt)
      api.resultsByTournament(id, nb)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tournament/:id/teams
    * @param id The tournament ID.
    */
  def teamsByTournament(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.teamsByTournament(id)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tournament/:id?page=[value]
    * @param id The tournament ID.
    */
  def tournament(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val page = request.getQueryString("page")
        .map(value => BigDecimal(value))
      api.tournament(id, page)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
