package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.BigDecimal
import model.Error
import model.NotFound
import model.OasAnyTypeNotMapped
import model.Ok
import model.VariantKey

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class BulkPairingsApiController @Inject()(cc: ControllerComponents, api: BulkPairingsApi) extends AbstractController(cc) {
  /**
    * POST /api/bulk-pairing
    */
  def bulkPairingCreate(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val players = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("players"))
        .flatMap(_.headOption)
        
      val clockPeriodlimit = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.limit"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
      val clockPeriodincrement = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.increment"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val pairAt = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("pairAt"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val startClocksAt = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("startClocksAt"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val rated = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("rated"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val variant = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("variant"))
        .flatMap(_.headOption)
        .map(value => )
      val message = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("message"))
        .flatMap(_.headOption)
        
      api.bulkPairingCreate(players, clockPeriodlimit, clockPeriodincrement, pairAt, startClocksAt, rated, variant, message)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * DELETE /api/bulk-pairing/:id
    */
  def bulkPairingDelete(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.bulkPairingDelete(id)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/bulk-pairing
    */
  def bulkPairingGet(): Action[AnyContent] = Action { request =>
    def executeApi(): List[OasAnyTypeNotMapped] = {
      api.bulkPairingGet()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/bulk-pairing/:id/start-clocks
    */
  def bulkPairingStartClocks(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.bulkPairingStartClocks(id)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
