package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.BigDecimal
import model.ChallengeJson
import model.Error
import model.GameJson
import model.InlineResponse2003
import model.NotFound
import model.OasAnyTypeNotMapped
import model.Ok
import model.VariantKey

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class ChallengesApiController @Inject()(cc: ControllerComponents, api: ChallengesApi) extends AbstractController(cc) {
  /**
    * POST /api/token/admin-challenge
    */
  def adminChallengeTokens(): Action[AnyContent] = Action { request =>
    def executeApi(): Unit = {
      val users = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("users"))
        .flatMap(_.headOption)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("users", "form")
        }
      val description = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("description"))
        .flatMap(_.headOption)
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("description", "form")
        }
      api.adminChallengeTokens(users, description)
    }

    executeApi()
    Ok
  }

  /**
    * POST /api/challenge/:challengeId/accept
    */
  def challengeAccept(challengeId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.challengeAccept(challengeId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/challenge/ai
    */
  def challengeAi(): Action[AnyContent] = Action { request =>
    def executeApi(): GameJson = {
      val level = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("level"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
      val clockPeriodlimit = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.limit"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
      val clockPeriodincrement = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.increment"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val days = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("days"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val color = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("color"))
        .flatMap(_.headOption)
        
      val variant = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("variant"))
        .flatMap(_.headOption)
        .map(value => )
      val fen = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("fen"))
        .flatMap(_.headOption)
        
      api.challengeAi(level, clockPeriodlimit, clockPeriodincrement, days, color, variant, fen)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/challenge/:challengeId/cancel?opponentToken=[value]
    */
  def challengeCancel(challengeId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val opponentToken = request.getQueryString("opponentToken")
        
      api.challengeCancel(challengeId, opponentToken)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/challenge/:username
    */
  def challengeCreate(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): ChallengeJson = {
      val rated = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("rated"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val clockPeriodlimit = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.limit"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
      val clockPeriodincrement = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.increment"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val days = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("days"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val color = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("color"))
        .flatMap(_.headOption)
        
      val variant = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("variant"))
        .flatMap(_.headOption)
        .map(value => )
      val fen = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("fen"))
        .flatMap(_.headOption)
        
      val keepAliveStream = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("keepAliveStream"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val acceptByToken = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("acceptByToken"))
        .flatMap(_.headOption)
        
      val message = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("message"))
        .flatMap(_.headOption)
        
      api.challengeCreate(username, rated, clockPeriodlimit, clockPeriodincrement, days, color, variant, fen, keepAliveStream, acceptByToken, message)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/challenge/:challengeId/decline
    */
  def challengeDecline(challengeId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val reason = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("reason"))
        .flatMap(_.headOption)
        
      api.challengeDecline(challengeId, reason)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/challenge
    */
  def challengeList(): Action[AnyContent] = Action { request =>
    def executeApi(): InlineResponse2003 = {
      api.challengeList()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/challenge/open
    */
  def challengeOpen(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val rated = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("rated"))
        .flatMap(_.headOption)
        .map(value => value.toBoolean)
      val clockPeriodlimit = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.limit"))
        .flatMap(_.headOption)
        .map(value => BigDecimal(value))
      val clockPeriodincrement = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("clock.increment"))
        .flatMap(_.headOption)
        .map(value => value.toInt)
      val variant = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("variant"))
        .flatMap(_.headOption)
        .map(value => )
      val fen = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("fen"))
        .flatMap(_.headOption)
        
      val name = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("name"))
        .flatMap(_.headOption)
        
      api.challengeOpen(rated, clockPeriodlimit, clockPeriodincrement, variant, fen, name)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/challenge/:gameId/start-clocks?token1=[value]&token2=[value]
    */
  def challengeStartClocks(gameId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val token1 = request.getQueryString("token1")
        
      val token2 = request.getQueryString("token2")
        
      api.challengeStartClocks(gameId, token1, token2)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/round/:gameId/add-time/:seconds
    * @param seconds How many seconds to give
    */
  def roundAddTime(gameId: String, seconds: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.roundAddTime(gameId, seconds)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
