package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.OasAnyTypeNotMapped
import model.PerfType

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class GamesApiController @Inject()(cc: ControllerComponents, api: GamesApi) extends AbstractController(cc) {
  /**
    * GET /api/account/playing?nb=[value]
    */
  def apiAccountPlaying(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val nb = request.getQueryString("nb")
        .map(value => value.toInt)
      api.apiAccountPlaying(nb)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/games/user/:username?since=[value]&until=[value]&max=[value]&vs=[value]&rated=[value]&perfType=[value]&color=[value]&analysed=[value]&moves=[value]&pgnInJson=[value]&tags=[value]&clocks=[value]&evals=[value]&opening=[value]&ongoing=[value]&finished=[value]&players=[value]&sort=[value]
    * @param username The user name.
    */
  def apiGamesUser(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val since = request.getQueryString("since")
        .map(value => value.toInt)
      val until = request.getQueryString("until")
        .map(value => value.toInt)
      val max = request.getQueryString("max")
        .map(value => value.toInt)
      val vs = request.getQueryString("vs")
        
      val rated = request.getQueryString("rated")
        .map(value => value.toBoolean)
      val perfType = request.getQueryString("perfType")
        .map(value => )
      val color = request.getQueryString("color")
        
      val analysed = request.getQueryString("analysed")
        .map(value => value.toBoolean)
      val moves = request.getQueryString("moves")
        .map(value => value.toBoolean)
      val pgnInJson = request.getQueryString("pgnInJson")
        .map(value => value.toBoolean)
      val tags = request.getQueryString("tags")
        .map(value => value.toBoolean)
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val evals = request.getQueryString("evals")
        .map(value => value.toBoolean)
      val opening = request.getQueryString("opening")
        .map(value => value.toBoolean)
      val ongoing = request.getQueryString("ongoing")
        .map(value => value.toBoolean)
      val finished = request.getQueryString("finished")
        .map(value => value.toBoolean)
      val players = request.getQueryString("players")
        
      val sort = request.getQueryString("sort")
        
      api.apiGamesUser(username, since, until, max, vs, rated, perfType, color, analysed, moves, pgnInJson, tags, clocks, evals, opening, ongoing, finished, players, sort)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/user/:username/current-game?moves=[value]&pgnInJson=[value]&tags=[value]&clocks=[value]&evals=[value]&opening=[value]&literate=[value]&players=[value]
    */
  def apiUserCurrentGame(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val moves = request.getQueryString("moves")
        .map(value => value.toBoolean)
      val pgnInJson = request.getQueryString("pgnInJson")
        .map(value => value.toBoolean)
      val tags = request.getQueryString("tags")
        .map(value => value.toBoolean)
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val evals = request.getQueryString("evals")
        .map(value => value.toBoolean)
      val opening = request.getQueryString("opening")
        .map(value => value.toBoolean)
      val literate = request.getQueryString("literate")
        .map(value => value.toBoolean)
      val players = request.getQueryString("players")
        
      api.apiUserCurrentGame(username, moves, pgnInJson, tags, clocks, evals, opening, literate, players)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/import
    */
  def gameImport(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val pgn = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("pgn"))
        .flatMap(_.headOption)
        
      api.gameImport(pgn)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /game/export/:gameId?moves=[value]&pgnInJson=[value]&tags=[value]&clocks=[value]&evals=[value]&opening=[value]&literate=[value]&players=[value]
    * @param gameId The game ID (8 characters).
    */
  def gamePgn(gameId: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val moves = request.getQueryString("moves")
        .map(value => value.toBoolean)
      val pgnInJson = request.getQueryString("pgnInJson")
        .map(value => value.toBoolean)
      val tags = request.getQueryString("tags")
        .map(value => value.toBoolean)
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val evals = request.getQueryString("evals")
        .map(value => value.toBoolean)
      val opening = request.getQueryString("opening")
        .map(value => value.toBoolean)
      val literate = request.getQueryString("literate")
        .map(value => value.toBoolean)
      val players = request.getQueryString("players")
        
      api.gamePgn(gameId, moves, pgnInJson, tags, clocks, evals, opening, literate, players)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/stream/games-by-users?withCurrentGames=[value]
    */
  def gamesByUsers(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val body = request.body.asJson.map(_.as[String]).getOrElse {
        throw new OpenApiExceptions.MissingRequiredParameterException("body", "body")
      }
      val withCurrentGames = request.getQueryString("withCurrentGames")
        .map(value => value.toBoolean)
      api.gamesByUsers(body, withCurrentGames)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /games/export/_ids?moves=[value]&pgnInJson=[value]&tags=[value]&clocks=[value]&evals=[value]&opening=[value]&players=[value]
    */
  def gamesExportIds(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val body = request.body.asJson.map(_.as[String]).getOrElse {
        throw new OpenApiExceptions.MissingRequiredParameterException("body", "body")
      }
      val moves = request.getQueryString("moves")
        .map(value => value.toBoolean)
      val pgnInJson = request.getQueryString("pgnInJson")
        .map(value => value.toBoolean)
      val tags = request.getQueryString("tags")
        .map(value => value.toBoolean)
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val evals = request.getQueryString("evals")
        .map(value => value.toBoolean)
      val opening = request.getQueryString("opening")
        .map(value => value.toBoolean)
      val players = request.getQueryString("players")
        
      api.gamesExportIds(body, moves, pgnInJson, tags, clocks, evals, opening, players)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/stream/game/:id
    */
  def streamGame(id: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.streamGame(id)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
