package api

import play.api.libs.json._
import model.Error

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait OAuthApi {
  /**
    * Obtain access token
    * OAuth2 token endpoint. Exchanges an authorization code for an access token. 
    * @param grantType Must be &#x60;authorization_code&#x60;.
    * @param code The authorization code that was sent in the &#x60;code&#x60; parameter to your &#x60;redirect_uri&#x60;.
    * @param codeVerifier A &#x60;code_challenge&#x60; was used to request the authorization code. This must be the &#x60;code_verifier&#x60; it was derived from.
    * @param redirectUri Must match the &#x60;redirect_uri&#x60; used to request the authorization code.
    * @param clientId Must match the &#x60;client_id&#x60; used to request the authorization code.
    */
  def apiToken(grantType: Option[String], code: Option[String], codeVerifier: Option[String], redirectUri: Option[String], clientId: Option[String]): Unit

  /**
    * Revoke access token
    * Revokes the access token sent as Bearer for this request.
    */
  def apiTokenDelete(): Unit

  /**
    * Request authorization code
    * OAuth2 authorization endpoint.  Start the OAuth2 Authorization Code Flow with PKCE by securely generating two random strings unique to each authorization request: * &#x60;code_verifier&#x60; * &#x60;state&#x60;  Store these in session storage. Make sure not to reveal &#x60;code_verifier&#x60; to eavesdroppers. Do not show it in URLs, do not abuse &#x60;state&#x60; to store it, do not send it over insecure connections. However it is fine if the user themselves can extract &#x60;code_verifier&#x60;, which will always be possible for fully client-side apps.  Then send the user to this endpoint. They will be prompted to grant authorization and then be redirected back to the given &#x60;redirect_uri&#x60;.  If the authorization failed, the following query string parameters will be appended to the redirection: * &#x60;error&#x60;, in particular with value &#x60;access_denied&#x60; if the user    cancelled authorization * &#x60;error_description&#x60; to aid debugging * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  If the authorization succeeded, the following query string parameters will be appended to the redirection: * &#x60;code&#x60;, containing a fresh short-lived authorization code * &#x60;state&#x60;, exactly as passed in the &#x60;state&#x60; parameter  Next, to defend against cross site request forgery, check that the returned &#x60;state&#x60; matches the &#x60;state&#x60; you originally generated.  Finally, continue by using the authorization code to [obtain an access token](#operation/apiToken). 
    * @param responseType Must be &#x60;code&#x60;.
    * @param clientId Arbitrary identifier that uniquely identifies your application.
    * @param redirectUri The absolute URL that the user should be redirected to with the authorization result.
    * @param codeChallengeMethod Must be &#x60;S256&#x60;.
    * @param codeChallenge Compute &#x60;BASE64URL(SHA256(code_verifier))&#x60;.
    * @param scope Space separated list of requested OAuth scopes, if any.
    * @param state Arbitrary state that will be returned verbatim with the authorization result.
    */
  def oauth(responseType: String, clientId: String, redirectUri: String, codeChallengeMethod: String, codeChallenge: String, scope: Option[String], state: Option[String]): Unit
}
