package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.Error

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class OAuthApiController @Inject()(cc: ControllerComponents, api: OAuthApi) extends AbstractController(cc) {
  /**
    * POST /api/token
    */
  def apiToken(): Action[AnyContent] = Action { request =>
    def executeApi(): Unit = {
      val grantType = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("grant_type"))
        .flatMap(_.headOption)
        
      val code = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("code"))
        .flatMap(_.headOption)
        
      val codeVerifier = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("code_verifier"))
        .flatMap(_.headOption)
        
      val redirectUri = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("redirect_uri"))
        .flatMap(_.headOption)
        
      val clientId = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("client_id"))
        .flatMap(_.headOption)
        
      api.apiToken(grantType, code, codeVerifier, redirectUri, clientId)
    }

    executeApi()
    Ok
  }

  /**
    * DELETE /api/token
    */
  def apiTokenDelete(): Action[AnyContent] = Action { request =>
    def executeApi(): Unit = {
      api.apiTokenDelete()
    }

    executeApi()
    Ok
  }

  /**
    * GET /oauth?responseType=[value]&clientId=[value]&redirectUri=[value]&codeChallengeMethod=[value]&codeChallenge=[value]&scope=[value]&state=[value]
    */
  def oauth(): Action[AnyContent] = Action { request =>
    def executeApi(): Unit = {
      val responseType = request.getQueryString("response_type")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("response_type", "query string")
        }
      val clientId = request.getQueryString("client_id")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("client_id", "query string")
        }
      val redirectUri = request.getQueryString("redirect_uri")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("redirect_uri", "query string")
        }
      val codeChallengeMethod = request.getQueryString("code_challenge_method")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("code_challenge_method", "query string")
        }
      val codeChallenge = request.getQueryString("code_challenge")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("code_challenge", "query string")
        }
      val scope = request.getQueryString("scope")
        
      val state = request.getQueryString("state")
        
      api.oauth(responseType, clientId, redirectUri, codeChallengeMethod, codeChallenge, scope, state)
    }

    executeApi()
    Ok
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
