package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.BigDecimal
import model.OasAnyTypeNotMapped
import model.Speed
import model.VariantKey

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class OpeningExplorerApiController @Inject()(cc: ControllerComponents, api: OpeningExplorerApi) extends AbstractController(cc) {
  /**
    * GET /lichess?variant=[value]&fen=[value]&play=[value]&speeds=[value]&ratings=[value]&since=[value]&until=[value]&moves=[value]&topGames=[value]&recentGames=[value]
    */
  def openingExplorerLichess(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val variant = request.getQueryString("variant")
        .map(value => )
      val fen = request.getQueryString("fen")
        
      val play = request.getQueryString("play")
        
      val speeds = request.queryString.get("speeds")
        .map(_.toList)
        .map(_.map(value => )
      val ratings = request.queryString.get("ratings")
        .map(_.toList)
        .map(_.map(value => BigDecimal(value))
      val since = request.getQueryString("since")
        
      val until = request.getQueryString("until")
        
      val moves = request.getQueryString("moves")
        .map(value => BigDecimal(value))
      val topGames = request.getQueryString("topGames")
        .map(value => BigDecimal(value))
      val recentGames = request.getQueryString("recentGames")
        .map(value => BigDecimal(value))
      api.openingExplorerLichess(variant, fen, play, speeds, ratings, since, until, moves, topGames, recentGames)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /masters?fen=[value]&play=[value]&since=[value]&until=[value]&moves=[value]&topGames=[value]
    */
  def openingExplorerMaster(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val fen = request.getQueryString("fen")
        
      val play = request.getQueryString("play")
        
      val since = request.getQueryString("since")
        .map(value => BigDecimal(value))
      val until = request.getQueryString("until")
        .map(value => BigDecimal(value))
      val moves = request.getQueryString("moves")
        .map(value => BigDecimal(value))
      val topGames = request.getQueryString("topGames")
        .map(value => BigDecimal(value))
      api.openingExplorerMaster(fen, play, since, until, moves, topGames)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /master/pgn/:gameId
    */
  def openingExplorerMasterGame(gameId: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.openingExplorerMasterGame(gameId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /player??variant=[value]&fen=[value]&play=[value]&speeds=[value]&modes=[value]&since=[value]&until=[value]&moves=[value]&recentGames=[value]
    */
  def openingExplorerPlayer(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val variant = request.getQueryString("variant")
        .map(value => )
      val fen = request.getQueryString("fen")
        
      val play = request.getQueryString("play")
        
      val speeds = request.queryString.get("speeds")
        .map(_.toList)
        .map(_.map(value => )
      val modes = request.queryString.get("modes")
        .map(_.toList)
      val since = request.getQueryString("since")
        
      val until = request.getQueryString("until")
        
      val moves = request.getQueryString("moves")
        .map(value => BigDecimal(value))
      val recentGames = request.getQueryString("recentGames")
        .map(value => BigDecimal(value))
      api.openingExplorerPlayer(variant, fen, play, speeds, modes, since, until, moves, recentGames)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
