package api

import play.api.libs.json._
import model.OasAnyTypeNotMapped
import model.PuzzleRoundJson

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait PuzzlesApi {
  /**
    * Get your puzzle activity
    * Download your puzzle activity in [ndjson](#section/Introduction/Streaming-with-ND-JSON) format.  Puzzle activity is sorted by reverse chronological order (most recent first)  We recommend streaming the response, for it can be very long. 
    * @param max How many entries to download. Leave empty to download all activity.
    */
  def apiPuzzleActivity(max: Option[Int]): PuzzleRoundJson

  /**
    * Get the daily puzzle
    * Get the daily Lichess puzzle in JSON format.  Alternatively, you can [post it in your slack workspace](https://lichess.org/daily-puzzle-slack). 
    */
  def apiPuzzleDaily(): OasAnyTypeNotMapped

  /**
    * Get your puzzle dashboard
    * Download your [puzzle dashboard](https://lichess.org/training/dashboard/30/dashboard) as JSON.  Also includes all puzzle themes played, with aggregated results.  Allows re-creating the [improvement/strengths](https://lichess.org/training/dashboard/30/improvementAreas) interfaces. 
    * @param days How many days to look back when aggregating puzzle results. 30 is sensible.
    */
  def apiPuzzleDashboard(days: Int): OasAnyTypeNotMapped

  /**
    * Get the storm dashboard of a player
    * Download the [storm dashboard](https://lichess.org/storm/dashboard/mrbasso) of any player as JSON.  Contains the aggregated highscores, and the history of storm runs aggregated by days.  Use &#x60;?days&#x3D;0&#x60; if you only care about the highscores. 
    * @param username Username of the player
    * @param days How many days of history to return
    */
  def apiStormDashboard(username: String, days: Option[Int]): OasAnyTypeNotMapped
}
