package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.OasAnyTypeNotMapped
import model.PuzzleRoundJson

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class PuzzlesApiController @Inject()(cc: ControllerComponents, api: PuzzlesApi) extends AbstractController(cc) {
  /**
    * GET /api/puzzle/activity?max=[value]
    */
  def apiPuzzleActivity(): Action[AnyContent] = Action { request =>
    def executeApi(): PuzzleRoundJson = {
      val max = request.getQueryString("max")
        .map(value => value.toInt)
      api.apiPuzzleActivity(max)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/puzzle/daily
    */
  def apiPuzzleDaily(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.apiPuzzleDaily()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/puzzle/dashboard/:days
    * @param days How many days to look back when aggregating puzzle results. 30 is sensible.
    */
  def apiPuzzleDashboard(days: Int): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.apiPuzzleDashboard(days)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/storm/dashboard/:username?days=[value]
    * @param username Username of the player
    */
  def apiStormDashboard(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val days = request.getQueryString("days")
        .map(value => value.toInt)
      api.apiStormDashboard(username, days)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
