package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.Ok
import model.UserExtended

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class RelationsApiController @Inject()(cc: ControllerComponents, api: RelationsApi) extends AbstractController(cc) {
  /**
    * GET /api/rel/following
    */
  def apiUserFollowing(): Action[AnyContent] = Action { request =>
    def executeApi(): UserExtended = {
      api.apiUserFollowing()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/rel/follow/:username
    */
  def followUser(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.followUser(username)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/rel/unfollow/:username
    */
  def unfollowUser(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.unfollowUser(username)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
