package api

import play.api.libs.json._
import model.OasAnyTypeNotMapped

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait StudiesApi {
  /**
    * Export all chapters
    * Download all chapters of a study in PGN format. 
    * @param studyId The study ID (8 characters).
    * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60; 
    * @param comments Include analysis and annotator comments in the PGN moves, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { White is in a pickle. }&#x60; 
    * @param variations Include non-mainline moves, when available.  Example: &#x60;4. d4 Bb4+ (4... Nc6 5. Nf3 Bb4+ 6. Bd2 (6. Nbd2 O-O 7. O-O) 6... Bd6) 5. Nd2&#x60; 
    */
  def studyAllChaptersPgn(studyId: String, clocks: Option[Boolean], comments: Option[Boolean], variations: Option[Boolean]): OasAnyTypeNotMapped

  /**
    * Export one study chapter
    * Download one study chapter in PGN format. 
    * @param studyId The study ID (8 characters).
    * @param chapterId The chapter ID (8 characters).
    * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60; 
    * @param comments Include analysis and annotator comments in the PGN moves, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { White is in a pickle. }&#x60; 
    * @param variations Include non-mainline moves, when available.  Example: &#x60;4. d4 Bb4+ (4... Nc6 5. Nf3 Bb4+ 6. Bd2 (6. Nbd2 O-O 7. O-O) 6... Bd6) 5. Nd2&#x60; 
    */
  def studyChapterPgn(studyId: String, chapterId: String, clocks: Option[Boolean], comments: Option[Boolean], variations: Option[Boolean]): OasAnyTypeNotMapped

  /**
    * Export all studies of a user
    * Download all chapters of all studies of a user in PGN format.  If authenticated, then all public, unlisted, and private studies are included.  If not, only public, listed studies are included. 
    * @param username The user whose studies we export
    * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60; 
    * @param comments Include analysis and annotator comments in the PGN moves, when available.  Example: &#x60;12. Bxf6 { [%eval 0.23] } a3 { White is in a pickle. }&#x60; 
    * @param variations Include non-mainline moves, when available.  Example: &#x60;4. d4 Bb4+ (4... Nc6 5. Nf3 Bb4+ 6. Bd2 (6. Nbd2 O-O 7. O-O) 6... Bd6) 5. Nd2&#x60; 
    */
  def studyExportAllPgn(username: String, clocks: Option[Boolean], comments: Option[Boolean], variations: Option[Boolean]): OasAnyTypeNotMapped
}
