package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.OasAnyTypeNotMapped

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class StudiesApiController @Inject()(cc: ControllerComponents, api: StudiesApi) extends AbstractController(cc) {
  /**
    * GET /api/study/:studyId.pgn?clocks=[value]&comments=[value]&variations=[value]
    * @param studyId The study ID (8 characters).
    */
  def studyAllChaptersPgn(studyId: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val comments = request.getQueryString("comments")
        .map(value => value.toBoolean)
      val variations = request.getQueryString("variations")
        .map(value => value.toBoolean)
      api.studyAllChaptersPgn(studyId, clocks, comments, variations)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /study/:studyId/:chapterId.pgn?clocks=[value]&comments=[value]&variations=[value]
    * @param studyId The study ID (8 characters).
    * @param chapterId The chapter ID (8 characters).
    */
  def studyChapterPgn(studyId: String, chapterId: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val comments = request.getQueryString("comments")
        .map(value => value.toBoolean)
      val variations = request.getQueryString("variations")
        .map(value => value.toBoolean)
      api.studyChapterPgn(studyId, chapterId, clocks, comments, variations)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /study/by/:username/export.pgn?clocks=[value]&comments=[value]&variations=[value]
    * @param username The user whose studies we export
    */
  def studyExportAllPgn(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val comments = request.getQueryString("comments")
        .map(value => value.toBoolean)
      val variations = request.getQueryString("variations")
        .map(value => value.toBoolean)
      api.studyExportAllPgn(username, clocks, comments, variations)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
