package api

import play.api.libs.json._
import model.BigDecimal
import model.OasAnyTypeNotMapped

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
trait TVApi {
  /**
    * Get best ongoing games of a TV channel
    * Get a list of ongoing games for a given TV channel. Similar to [lichess.org/games](https://lichess.org/games).  Available in PGN or [ndjson](#section/Introduction/Streaming-with-ND-JSON) format, depending on the request Accept header. 
    * @param channel The name of the channel in lowercase.
    * @param nb Number of games to fetch.
    * @param moves Include the PGN moves.
    * @param pgnInJson Include the full PGN within the JSON response, in a &#x60;pgn&#x60; field.
    * @param tags Include the PGN tags.
    * @param clocks Include clock comments in the PGN moves, when available.  Example: &#x60;2. exd5 { [%clk 1:01:27] } e5 { [%clk 1:01:28] }&#x60; 
    * @param opening Include the opening name.  Example: &#x60;[Opening \&quot;King&#39;s Gambit Accepted, King&#39;s Knight Gambit\&quot;]&#x60; 
    */
  def tvChannelGames(channel: String, nb: Option[BigDecimal], moves: Option[Boolean], pgnInJson: Option[Boolean], tags: Option[Boolean], clocks: Option[Boolean], opening: Option[Boolean]): OasAnyTypeNotMapped

  /**
    * Get current TV games
    * Get basic info about the best games being played for each speed and variant, but also computer games and bot games.  See [lichess.org/tv](https://lichess.org/tv). 
    */
  def tvChannels(): OasAnyTypeNotMapped

  /**
    * Stream current TV game
    * Stream positions and moves of the current [TV game](https://lichess.org/tv) in [ndjson](#section/Introduction/Streaming-with-ND-JSON). A summary of the game is sent as a first message, and when the featured game changes.  Try it with &#x60;curl https://lichess.org/api/tv/feed&#x60;. 
    */
  def tvFeed(): OasAnyTypeNotMapped
}
