package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.BigDecimal
import model.OasAnyTypeNotMapped

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class TVApiController @Inject()(cc: ControllerComponents, api: TVApi) extends AbstractController(cc) {
  /**
    * GET /api/tv/:channel?nb=[value]&moves=[value]&pgnInJson=[value]&tags=[value]&clocks=[value]&opening=[value]
    * @param channel The name of the channel in lowercase.
    */
  def tvChannelGames(channel: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val nb = request.getQueryString("nb")
        .map(value => BigDecimal(value))
      val moves = request.getQueryString("moves")
        .map(value => value.toBoolean)
      val pgnInJson = request.getQueryString("pgnInJson")
        .map(value => value.toBoolean)
      val tags = request.getQueryString("tags")
        .map(value => value.toBoolean)
      val clocks = request.getQueryString("clocks")
        .map(value => value.toBoolean)
      val opening = request.getQueryString("opening")
        .map(value => value.toBoolean)
      api.tvChannelGames(channel, nb, moves, pgnInJson, tags, clocks, opening)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tv/channels
    */
  def tvChannels(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.tvChannels()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/tv/feed
    */
  def tvFeed(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.tvFeed()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
