package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.TablebaseJson

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class TablebaseApiController @Inject()(cc: ControllerComponents, api: TablebaseApi) extends AbstractController(cc) {
  /**
    * GET /antichess
    */
  def antichessAtomic(): Action[AnyContent] = Action { request =>
    def executeApi(): String = {
      api.antichessAtomic()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /atomic
    */
  def tablebaseAtomic(): Action[AnyContent] = Action { request =>
    def executeApi(): String = {
      api.tablebaseAtomic()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /standard?fen=[value]
    */
  def tablebaseStandard(): Action[AnyContent] = Action { request =>
    def executeApi(): TablebaseJson = {
      val fen = request.getQueryString("fen")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("fen", "query string")
        }
      api.tablebaseStandard(fen)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
