package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.BigDecimal
import model.Error
import model.InlineResponse2001
import model.OasAnyTypeNotMapped
import model.Ok
import model.Team
import model.UserExtended

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class TeamsApiController @Inject()(cc: ControllerComponents, api: TeamsApi) extends AbstractController(cc) {
  /**
    * GET /api/team/:teamId/arena?max=[value]
    * @param teamId ID of the team
    */
  def apiTeamArena(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): List[OasAnyTypeNotMapped] = {
      val max = request.getQueryString("max")
        .map(value => value.toInt)
      api.apiTeamArena(teamId, max)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/:teamId/swiss?max=[value]
    */
  def apiTeamSwiss(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): List[OasAnyTypeNotMapped] = {
      val max = request.getQueryString("max")
        .map(value => value.toInt)
      api.apiTeamSwiss(teamId, max)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/all?page=[value]
    */
  def teamAll(): Action[AnyContent] = Action { request =>
    def executeApi(): InlineResponse2001 = {
      val page = request.getQueryString("page")
        .map(value => BigDecimal(value))
      api.teamAll(page)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /team/:teamId/join
    */
  def teamIdJoin(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val message = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("message"))
        .flatMap(_.headOption)
        
      val password = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("password"))
        .flatMap(_.headOption)
        
      api.teamIdJoin(teamId, message, password)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /team/:teamId/kick/:userId
    */
  def teamIdKickUserId(teamId: String, userId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.teamIdKickUserId(teamId, userId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /team/:teamId/pm-all
    */
  def teamIdPmAll(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      val message = (request.body.asMultipartFormData.map(_.asFormUrlEncoded) orElse request.body.asFormUrlEncoded)
        .flatMap(_.get("message"))
        .flatMap(_.headOption)
        
      api.teamIdPmAll(teamId, message)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /team/:teamId/quit
    */
  def teamIdQuit(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Ok = {
      api.teamIdQuit(teamId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/:teamId/users
    */
  def teamIdUsers(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): UserExtended = {
      api.teamIdUsers(teamId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/of/:username
    */
  def teamOfUsername(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): List[Team] = {
      api.teamOfUsername(username)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/search?text=[value]&page=[value]
    */
  def teamSearch(): Action[AnyContent] = Action { request =>
    def executeApi(): List[Team] = {
      val text = request.getQueryString("text")
        
      val page = request.getQueryString("page")
        .map(value => BigDecimal(value))
      api.teamSearch(text, page)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/:teamId
    */
  def teamShow(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): Team = {
      api.teamShow(teamId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
