package api

import org.openapitools.OpenApiExceptions
import javax.inject.{Inject, Singleton}
import play.api.libs.json._
import play.api.mvc._
import model.InlineResponse200
import model.InlineResponse2002
import model.OasAnyTypeNotMapped
import model.PerfType
import model.User
import model.UserExtended

@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
@Singleton
class UsersApiController @Inject()(cc: ControllerComponents, api: UsersApi) extends AbstractController(cc) {
  /**
    * GET /api/crosstable/:user1/:user2?matchup=[value]
    */
  def apiCrosstable(user1: String, user2: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      val matchup = request.getQueryString("matchup")
        .map(value => value.toBoolean)
      api.apiCrosstable(user1, user2, matchup)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/user/:username
    */
  def apiUser(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): UserExtended = {
      api.apiUser(username)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/user/:username/activity
    */
  def apiUserActivity(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): Unit = {
      api.apiUserActivity(username)
    }

    executeApi()
    Ok
  }

  /**
    * GET /api/user/:username/perf/:perf
    */
  def apiUserPerf(username: String, perf: PerfType): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.apiUserPerf(username, perf)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/user/:username/rating-history
    */
  def apiUserRatingHistory(username: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.apiUserRatingHistory(username)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * POST /api/users
    */
  def apiUsers(): Action[AnyContent] = Action { request =>
    def executeApi(): List[User] = {
      val body = request.body.asJson.map(_.as[String]).getOrElse {
        throw new OpenApiExceptions.MissingRequiredParameterException("body", "body")
      }
      api.apiUsers(body)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/users/status?ids=[value]
    */
  def apiUsersStatus(): Action[AnyContent] = Action { request =>
    def executeApi(): List[InlineResponse200] = {
      val ids = request.getQueryString("ids")
        .getOrElse {
          throw new OpenApiExceptions.MissingRequiredParameterException("ids", "query string")
        }
      api.apiUsersStatus(ids)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /player
    */
  def player(): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.player()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /player/top/:nb/:perfType
    * @param nb How many users to fetch
    * @param perfType The speed or variant
    */
  def playerTopNbPerfType(nb: Int, perfType: String): Action[AnyContent] = Action { request =>
    def executeApi(): OasAnyTypeNotMapped = {
      api.playerTopNbPerfType(nb, perfType)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /streamer/live
    */
  def streamerLive(): Action[AnyContent] = Action { request =>
    def executeApi(): List[InlineResponse2002] = {
      api.streamerLive()
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  /**
    * GET /api/team/:teamId/users
    */
  def teamIdUsers(teamId: String): Action[AnyContent] = Action { request =>
    def executeApi(): UserExtended = {
      api.teamIdUsers(teamId)
    }

    val result = executeApi()
    val json = Json.toJson(result)
    Ok(json)
  }

  private def splitCollectionParam(paramValues: String, collectionFormat: String): List[String] = {
    val splitBy =
      collectionFormat match {
        case "csv" => ",+"
        case "tsv" => "\t+"
        case "ssv" => " +"
        case "pipes" => "|+"
      }

    paramValues.split(splitBy).toList
  }
}
