package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for ChallengeJson.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class ChallengeJson(
  id: String,
  url: String,
  status: ChallengeJson.Status.Value,
  challenger: ChallengeUser,
  destUser: ChallengeUser,
  variant: Variant,
  rated: Boolean,
  speed: Speed,
  timeControl: TimeControl,
  color: ChallengeJson.Color.Value,
  perf: ChallengeJsonPerf,
  direction: Option[ChallengeJson.Direction.Value],
  initialFen: Option[String],
  declineReason: Option[String]
  additionalProperties: 
)

object ChallengeJson {
  implicit lazy val challengeJsonJsonFormat: Format[ChallengeJson] = {
    val realJsonFormat = Json.format[ChallengeJson]
    val declaredPropNames = Set("id", "url", "status", "challenger", "destUser", "variant", "rated", "speed", "timeControl", "color", "perf", "direction", "initialFen", "declineReason")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { challengeJson =>
        val jsObj = realJsonFormat.writes(challengeJson)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Status extends Enumeration {
    val Created = Value("created")
    val Offline = Value("offline")
    val Canceled = Value("canceled")
    val Declined = Value("declined")
    val Accepted = Value("accepted")

    type Status = Value
    implicit lazy val StatusJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }

  // noinspection TypeAnnotation
  object Color extends Enumeration {
    val White = Value("white")
    val Black = Value("black")
    val Random = Value("random")

    type Color = Value
    implicit lazy val ColorJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }

  // noinspection TypeAnnotation
  object Direction extends Enumeration {
    val In = Value("in")
    val Out = Value("out")

    type Direction = Value
    implicit lazy val DirectionJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

