package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameFullEvent.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameFullEvent(
  id: String,
  variant: Variant,
  clock: Clock,
  speed: Speed,
  perf: GameFullEventPerf,
  rated: Boolean,
  createdAt: BigDecimal,
  white: GameEventPlayer,
  black: GameEventPlayer,
  initialFen: GameFullEvent.InitialFen.Value,
  state: GameStateEvent,
  tournamentId: Option[String]
  additionalProperties: 
)

object GameFullEvent {
  implicit lazy val gameFullEventJsonFormat: Format[GameFullEvent] = {
    val realJsonFormat = Json.format[GameFullEvent]
    val declaredPropNames = Set("id", "variant", "clock", "speed", "perf", "rated", "createdAt", "white", "black", "initialFen", "state", "tournamentId")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameFullEvent =>
        val jsObj = realJsonFormat.writes(gameFullEvent)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object InitialFen extends Enumeration {
    val Startpos = Value("startpos")

    type InitialFen = Value
    implicit lazy val InitialFenJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

