package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameJson.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameJson(
  id: String,
  rated: Boolean,
  variant: VariantKey,
  speed: Speed,
  perf: String,
  createdAt: BigDecimal,
  lastMoveAt: BigDecimal,
  status: GameStatus,
  players: GameJsonPlayers,
  initialFen: Option[String],
  winner: Option[GameJson.Winner.Value],
  opening: Option[GameJsonOpening],
  moves: Option[String],
  pgn: Option[String],
  daysPerTurn: Option[BigDecimal],
  analysis: Option[List[GameJsonAnalysis]],
  tournament: Option[String],
  swiss: Option[String],
  clock: Option[GameJsonClock]
  additionalProperties: 
)

object GameJson {
  implicit lazy val gameJsonJsonFormat: Format[GameJson] = {
    val realJsonFormat = Json.format[GameJson]
    val declaredPropNames = Set("id", "rated", "variant", "speed", "perf", "createdAt", "lastMoveAt", "status", "players", "initialFen", "winner", "opening", "moves", "pgn", "daysPerTurn", "analysis", "tournament", "swiss", "clock")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameJson =>
        val jsObj = realJsonFormat.writes(gameJson)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Winner extends Enumeration {
    val White = Value("white")
    val Black = Value("black")

    type Winner = Value
    implicit lazy val WinnerJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

