package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameJson_analysis.
  * @param eval Evaluation in centipawns
  * @param best Best move in UCI notation (only if played move was inaccurate)
  * @param variation Best variation in SAN notation (only if played move was inaccurate)
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameJsonAnalysis(
  eval: BigDecimal,
  best: Option[String],
  variation: Option[String],
  judgment: Option[GameJsonJudgment]
  additionalProperties: 
)

object GameJsonAnalysis {
  implicit lazy val gameJsonAnalysisJsonFormat: Format[GameJsonAnalysis] = {
    val realJsonFormat = Json.format[GameJsonAnalysis]
    val declaredPropNames = Set("eval", "best", "variation", "judgment")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameJsonAnalysis =>
        val jsObj = realJsonFormat.writes(gameJsonAnalysis)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

