package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for GameStateEvent.
  * @param moves Current moves in UCI format
  * @param wtime Integer of milliseconds White has left on the clock
  * @param btime Integer of milliseconds Black has left on the clock
  * @param winc Integer of White Fisher increment.
  * @param binc Integer of Black Fisher increment.
  * @param winner Color of the winner, if any
  * @param wdraw true if white is offering draw, else omitted
  * @param bdraw true if black is offering draw, else omitted
  * @param wtakeback true if white is proposing takeback, else omitted
  * @param btakeback true if black is proposing takeback, else omitted
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class GameStateEvent(
  moves: String,
  wtime: Int,
  btime: Int,
  winc: Int,
  binc: Int,
  status: GameStatus,
  winner: Option[String],
  wdraw: Option[Boolean],
  bdraw: Option[Boolean],
  wtakeback: Option[Boolean],
  btakeback: Option[Boolean]
  additionalProperties: 
)

object GameStateEvent {
  implicit lazy val gameStateEventJsonFormat: Format[GameStateEvent] = {
    val realJsonFormat = Json.format[GameStateEvent]
    val declaredPropNames = Set("moves", "wtime", "btime", "winc", "binc", "status", "winner", "wdraw", "bdraw", "wtakeback", "btakeback")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { gameStateEvent =>
        val jsObj = realJsonFormat.writes(gameStateEvent)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }
}

