package model

import play.api.libs.json._

/**
  * Represents the Swagger definition for Move.
  * @param dtz DTZ50'' with rounding or null if unknown
  * @param dtm Distance to mate (only for positions with not more than 5 pieces)
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class Move(
  uci: Option[String],
  san: Option[String],
  category: Option[Move.Category.Value],
  dtz: Option[Int],
  dtm: Option[Int],
  zeroing: Option[Boolean],
  checkmate: Option[Boolean],
  stalemate: Option[Boolean],
  variantWin: Option[Boolean],
  variantLoss: Option[Boolean],
  insufficientMaterial: Option[Boolean]
  additionalProperties: 
)

object Move {
  implicit lazy val moveJsonFormat: Format[Move] = {
    val realJsonFormat = Json.format[Move]
    val declaredPropNames = Set("uci", "san", "category", "dtz", "dtm", "zeroing", "checkmate", "stalemate", "variantWin", "variantLoss", "insufficientMaterial")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { move =>
        val jsObj = realJsonFormat.writes(move)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Category extends Enumeration {
    val Loss = Value("loss")
    val Unknown = Value("unknown")
    val MaybeLoss = Value("maybe-loss")
    val BlessedLoss = Value("blessed-loss")
    val Draw = Value("draw")
    val CursedWin = Value("cursed-win")
    val MaybeWin = Value("maybe-win")
    val Win = Value("win")

    type Category = Value
    implicit lazy val CategoryJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

