package model

import play.api.libs.json._
import java.net.URI

/**
  * Represents the Swagger definition for UserPreferences.
  * @param additionalProperties Any additional properties this model may have.
  */
@javax.annotation.Generated(value = Array("org.openapitools.codegen.languages.ScalaPlayFrameworkServerCodegen"), date = "2021-12-01T01:36:35.216324+01:00[Europe/Vienna]")
case class UserPreferences(
  dark: Option[Boolean],
  transp: Option[Boolean],
  bgImg: Option[URI],
  is3d: Option[Boolean],
  theme: Option[UserPreferences.Theme.Value],
  pieceSet: Option[UserPreferences.PieceSet.Value],
  theme3d: Option[UserPreferences.Theme3d.Value],
  pieceSet3d: Option[UserPreferences.PieceSet3d.Value],
  soundSet: Option[UserPreferences.SoundSet.Value],
  blindfold: Option[Int],
  autoQueen: Option[Int],
  autoThreefold: Option[Int],
  takeback: Option[Int],
  moretime: Option[Int],
  clockTenths: Option[Int],
  clockBar: Option[Boolean],
  clockSound: Option[Boolean],
  premove: Option[Boolean],
  animation: Option[Int],
  captured: Option[Boolean],
  follow: Option[Boolean],
  highlight: Option[Boolean],
  destination: Option[Boolean],
  coords: Option[Int],
  replay: Option[Int],
  challenge: Option[Int],
  message: Option[Int],
  coordColor: Option[Int],
  submitMove: Option[Int],
  confirmResign: Option[Int],
  insightShare: Option[Int],
  keyboardMove: Option[Int],
  zen: Option[Int],
  moveEvent: Option[Int],
  rookCastle: Option[Int]
  additionalProperties: 
)

object UserPreferences {
  implicit lazy val userPreferencesJsonFormat: Format[UserPreferences] = {
    val realJsonFormat = Json.format[UserPreferences]
    val declaredPropNames = Set("dark", "transp", "bgImg", "is3d", "theme", "pieceSet", "theme3d", "pieceSet3d", "soundSet", "blindfold", "autoQueen", "autoThreefold", "takeback", "moretime", "clockTenths", "clockBar", "clockSound", "premove", "animation", "captured", "follow", "highlight", "destination", "coords", "replay", "challenge", "message", "coordColor", "submitMove", "confirmResign", "insightShare", "keyboardMove", "zen", "moveEvent", "rookCastle")
    
    Format(
      Reads {
        case JsObject(xs) =>
          val declaredProps = xs.filterKeys(declaredPropNames)
          val additionalProps = JsObject(xs -- declaredPropNames)
          val restructuredProps = declaredProps + ("additionalProperties" -> additionalProps)
          val newObj = JsObject(restructuredProps)
          realJsonFormat.reads(newObj)
        case _ =>
          JsError("error.expected.jsobject")
      },
      Writes { userPreferences =>
        val jsObj = realJsonFormat.writes(userPreferences)
        val additionalProps = jsObj.value("additionalProperties").as[JsObject]
        val declaredProps = jsObj - "additionalProperties"
        val newObj = declaredProps ++ additionalProps
        newObj
      }
    )
  }

  // noinspection TypeAnnotation
  object Theme extends Enumeration {
    val Blue = Value("blue")
    val Blue2 = Value("blue2")
    val Blue3 = Value("blue3")
    val BlueMarble = Value("blue-marble")
    val Canvas = Value("canvas")
    val Wood = Value("wood")
    val Wood2 = Value("wood2")
    val Wood3 = Value("wood3")
    val Wood4 = Value("wood4")
    val Maple = Value("maple")
    val Maple2 = Value("maple2")
    val Brown = Value("brown")
    val Leather = Value("leather")
    val Green = Value("green")
    val Marble = Value("marble")
    val GreenPlastic = Value("green-plastic")
    val Grey = Value("grey")
    val Metal = Value("metal")
    val Olive = Value("olive")
    val Newspaper = Value("newspaper")
    val Purple = Value("purple")
    val PurpleDiag = Value("purple-diag")
    val Pink = Value("pink")
    val Ic = Value("ic")

    type Theme = Value
    implicit lazy val ThemeJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }

  // noinspection TypeAnnotation
  object PieceSet extends Enumeration {
    val Cburnett = Value("cburnett")
    val Merida = Value("merida")
    val Alpha = Value("alpha")
    val Pirouetti = Value("pirouetti")
    val Chessnut = Value("chessnut")
    val Chess7 = Value("chess7")
    val Reillycraig = Value("reillycraig")
    val Companion = Value("companion")
    val Riohacha = Value("riohacha")
    val Kosal = Value("kosal")
    val Leipzig = Value("leipzig")
    val Fantasy = Value("fantasy")
    val Spatial = Value("spatial")
    val California = Value("california")
    val Pixel = Value("pixel")
    val Maestro = Value("maestro")
    val Fresca = Value("fresca")
    val Cardinal = Value("cardinal")
    val Gioco = Value("gioco")
    val Tatiana = Value("tatiana")
    val Staunty = Value("staunty")
    val Governor = Value("governor")
    val Dubrovny = Value("dubrovny")
    val Icpieces = Value("icpieces")
    val Shapes = Value("shapes")
    val Letter = Value("letter")

    type PieceSet = Value
    implicit lazy val PieceSetJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }

  // noinspection TypeAnnotation
  object Theme3d extends Enumeration {
    val BlackWhiteAluminium = Value("Black-White-Aluminium")
    val BrushedAluminium = Value("Brushed-Aluminium")
    val ChinaBlue = Value("China-Blue")
    val ChinaGreen = Value("China-Green")
    val ChinaGrey = Value("China-Grey")
    val ChinaScarlet = Value("China-Scarlet")
    val ClassicBlue = Value("Classic-Blue")
    val GoldSilver = Value("Gold-Silver")
    val LightWood = Value("Light-Wood")
    val PowerCoated = Value("Power-Coated")
    val Rosewood = Value("Rosewood")
    val Marble = Value("Marble")
    val Wax = Value("Wax")
    val Jade = Value("Jade")
    val Woodi = Value("Woodi")

    type Theme3d = Value
    implicit lazy val Theme3dJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }

  // noinspection TypeAnnotation
  object PieceSet3d extends Enumeration {
    val Basic = Value("Basic")
    val Wood = Value("Wood")
    val Metal = Value("Metal")
    val RedVBlue = Value("RedVBlue")
    val ModernJade = Value("ModernJade")
    val ModernWood = Value("ModernWood")
    val Glass = Value("Glass")
    val Trimmed = Value("Trimmed")
    val Experimental = Value("Experimental")
    val Staunton = Value("Staunton")
    val CubesAndPi = Value("CubesAndPi")

    type PieceSet3d = Value
    implicit lazy val PieceSet3dJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }

  // noinspection TypeAnnotation
  object SoundSet extends Enumeration {
    val Silent = Value("silent")
    val Standard = Value("standard")
    val Piano = Value("piano")
    val Nes = Value("nes")
    val Sfx = Value("sfx")
    val Futuristic = Value("futuristic")
    val Robot = Value("robot")
    val Music = Value("music")
    val Speech = Value("speech")

    type SoundSet = Value
    implicit lazy val SoundSetJsonFormat: Format[Value] = Format(Reads.enumNameReads(this), Writes.enumNameWrites[this.type])
  }
}

